-----------------------------------------------------------------
--|> FOCUS FRAME
-----------------------------------------------------------------

--> Libs
local RC = LibStub("LibRangeCheck-2.0")

--> Upvalues
local C_NamePlate_GetNamePlateForUnit = C_NamePlate.GetNamePlateForUnit
local C_Timer_NewTicker = C_Timer.NewTicker

--> Timer
local RangeCheckTicker

--|> FRANE
-----------------------------------------------------------------
FTL_FOCUS_FRAME = FTL_FOCUS_FRAME or CreateFrame("Frame", "FTL_FOCUS_FRAME", UIParent)
FTL_FOCUS_FRAME:SetFrameStrata("DIALOG")
FTL_FOCUS_FRAME:SetPoint("CENTER", UIParent)
FTL_FOCUS_FRAME:SetSize(64, 64)
FTL_FOCUS_FRAME:SetIgnoreParentAlpha(true)
FTL_FOCUS_FRAME:SetAlpha(0)

--> Range Text
FTL_FOCUS_FRAME.RangeText = FTL_FOCUS_FRAME:CreateFontString(nil, "ARTWORK", nil)
FTL_FOCUS_FRAME.RangeText:SetFont([[interface\addons\FTL\Media\Fonts\RobotoCondensed-Bold.ttf]], 20, "OUTLINE")
FTL_FOCUS_FRAME.RangeText:SetPoint("BOTTOM", FTL_FOCUS_FRAME, "TOP", 0, 2)
FTL_FOCUS_FRAME.RangeText:SetJustifyH("CENTER")
FTL_FOCUS_FRAME.RangeText:SetShadowOffset(1, -1)
FTL_FOCUS_FRAME.RangeText:SetText("--")
FTL_FOCUS_FRAME.RangeText:SetDrawLayer("ARTWORK", 7)

--> Texture
FTL_FOCUS_FRAME.icon = FTL_FOCUS_FRAME:CreateTexture(nil, "ARTWORK", FTL_FOCUS_FRAME)
FTL_FOCUS_FRAME.icon:SetTexture([[interface/addons/FTL/Media/Textures/fTexture.tga]])
FTL_FOCUS_FRAME.icon:SetAllPoints()
FTL_FOCUS_FRAME.icon:SetAlpha(1)
FTL_FOCUS_FRAME.icon:SetBlendMode("BLEND")
FTL_FOCUS_FRAME.faction = FTL_FOCUS_FRAME:CreateTexture(nil, "OVERLAY", FTL_FOCUS_FRAME)
FTL_FOCUS_FRAME.faction:SetTexture([[interface/Timer/Horde-Logo]])
FTL_FOCUS_FRAME.faction:SetDrawLayer("OVERLAY", 2)
FTL_FOCUS_FRAME.faction:SetPoint("TOPLEFT", FTL_FOCUS_FRAME, "TOPLEFT", 2, -2)
FTL_FOCUS_FRAME.faction:SetPoint("BOTTOMRIGHT", FTL_FOCUS_FRAME, "BOTTOMRIGHT", -2, 2)
FTL_FOCUS_FRAME.faction:SetVertexColor(1, 1, 1, 1)

--|> ANIMATIONS
-----------------------------------------------------------------
--> Fade In
FTL_FOCUS_FRAME.FadeIn = FTL_FOCUS_FRAME:CreateAnimationGroup()
FTL_FOCUS_FRAME.FadeIn.s1 = FTL_FOCUS_FRAME.FadeIn:CreateAnimation("Scale")
FTL_FOCUS_FRAME.FadeIn.s1:SetFromScale(4, 4)
FTL_FOCUS_FRAME.FadeIn.s1:SetToScale(1, 1)
FTL_FOCUS_FRAME.FadeIn.s1:SetDuration(0.25)
FTL_FOCUS_FRAME.FadeIn.s1:SetSmoothing("OUT")
FTL_FOCUS_FRAME.FadeIn.s1:SetOrder(1)
FTL_FOCUS_FRAME.FadeIn.a1 = FTL_FOCUS_FRAME.FadeIn:CreateAnimation("Alpha")
FTL_FOCUS_FRAME.FadeIn.a1:SetFromAlpha(0)
FTL_FOCUS_FRAME.FadeIn.a1:SetToAlpha(1)
FTL_FOCUS_FRAME.FadeIn.a1:SetDuration(0.25)
FTL_FOCUS_FRAME.FadeIn.a1:SetSmoothing("OUT")
FTL_FOCUS_FRAME.FadeIn.a1:SetOrder(1)

--> Estimate Unit Range
local function EstimateUnitRange(unit)
    local minRange, maxRange = RC:GetRange(unit)
    if not minRange then
        return "--"
    elseif not maxRange then
        return minRange, "+"
    elseif minRange == 0 then
        return ""
    else
        return minRange
    end
end

-->  Get estimated distance
local range, txt
local function UpdateDistance()
    range, txt = EstimateUnitRange("focus")
    if range then
        if txt ~= nil then
            range = range .. txt
        end
        FTL_FOCUS_FRAME.RangeText:SetText(range)
    end
end

--|> FUNCTIONS
-----------------------------------------------------------------
--> Hide
function FTL_FOCUS_FRAME.Hide()
    RangeCheckTicker:Cancel()
    FTL_FOCUS_TARGET_FRAME.Hide()
    FTL_FOCUS_FRAME:SetAlpha(0)
    FTL_FOCUS_FRAME:ClearAllPoints()
    FTL_FOCUS_FRAME.RangeText:SetText("")
    FTL_FOCUS_FRAME:StopAnimating()
end

--> Show
function FTL_FOCUS_FRAME.Show()
    RangeCheckTicker = C_Timer_NewTicker(0.6, UpdateDistance)
    local nameplate = C_NamePlate_GetNamePlateForUnit("focus")
    if nameplate then
        -- FTL_FOCUS_FRAME.FadeIn:Play()
        FTL_FOCUS_FRAME:ClearAllPoints()
        FTL_FOCUS_FRAME:SetPoint("BOTTOM", nameplate, "CENTER", 0, 30)
        FTL_FOCUS_FRAME:SetAlpha(1)
        FTL_FOCUS_FRAME:StopAnimating()
    else
        FTL_FOCUS_FRAME.Hide()
    end
end
