-----------------------------------------------------------------
--|> FOCUS TARGET FRAME
-------------------------------------------------------------------------------
--> Upvalues
local C_NamePlate_GetNamePlateForUnit = C_NamePlate.GetNamePlateForUnit

--|> FRAME
-----------------------------------------------------------------
FTL_FOCUS_TARGET_FRAME = FTL_FOCUS_TARGET_FRAME or CreateFrame("Frame", "FTL_FOCUS_TARGET_FRAME", UIParent)
FTL_FOCUS_TARGET_FRAME:SetFrameStrata("HIGH")
FTL_FOCUS_TARGET_FRAME:SetPoint("CENTER", UIParent)
FTL_FOCUS_TARGET_FRAME:SetSize(32, 32)
FTL_FOCUS_TARGET_FRAME:SetIgnoreParentAlpha(true)
FTL_FOCUS_TARGET_FRAME:SetAlpha(0)

--> Icon
FTL_FOCUS_TARGET_FRAME.icon = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "ARTWORK", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.icon:SetTexture([[interface/addons/FTL/Media/Textures/ftTexture.tga]])
FTL_FOCUS_TARGET_FRAME.icon:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")
FTL_FOCUS_TARGET_FRAME.icon:SetSize(32, 32)
FTL_FOCUS_TARGET_FRAME.icon:SetDrawLayer("OVERLAY", 1)
FTL_FOCUS_TARGET_FRAME.icon:SetVertexColor(1, 0.49, 0, 1)
FTL_FOCUS_TARGET_FRAME.icon:SetBlendMode("ADD")

--> Outline
FTL_FOCUS_TARGET_FRAME.outline = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "BACKGROUND", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.outline:SetTexture([[interface/addons/FTL/Media/Textures/ftOutline.tga]])
FTL_FOCUS_TARGET_FRAME.outline:SetAllPoints()
FTL_FOCUS_TARGET_FRAME.outline:SetVertexColor(1, 1, 1, 0.8)
FTL_FOCUS_TARGET_FRAME.outline:SetDrawLayer("ARTWORK", 7)
FTL_FOCUS_TARGET_FRAME.outline:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")

--> Shadow
FTL_FOCUS_TARGET_FRAME.shadow = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "BACKGROUND", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.shadow:SetTexture([[interface/addons/FTL/Media/Textures/ftShadow.tga]])
FTL_FOCUS_TARGET_FRAME.shadow:SetVertexColor(0, 0, 0, 0.5)
FTL_FOCUS_TARGET_FRAME.shadow:SetDrawLayer("BACKGROUND")
FTL_FOCUS_TARGET_FRAME.shadow:SetAllPoints()
FTL_FOCUS_TARGET_FRAME.shadow:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")

--|> ANIMATIONS
-----------------------------------------------------------------

--> Fade In
FTL_FOCUS_TARGET_FRAME.FadeIn = FTL_FOCUS_TARGET_FRAME:CreateAnimationGroup()
FTL_FOCUS_TARGET_FRAME.FadeIn.s1 = FTL_FOCUS_TARGET_FRAME.FadeIn:CreateAnimation("Scale")
FTL_FOCUS_TARGET_FRAME.FadeIn.s1:SetFromScale(4, 4)
FTL_FOCUS_TARGET_FRAME.FadeIn.s1:SetToScale(1, 1)
FTL_FOCUS_TARGET_FRAME.FadeIn.s1:SetDuration(0.25)
FTL_FOCUS_TARGET_FRAME.FadeIn.s1:SetSmoothing("IN")
FTL_FOCUS_TARGET_FRAME.FadeIn.s1:SetOrder(1)
FTL_FOCUS_TARGET_FRAME.FadeIn.a1 = FTL_FOCUS_TARGET_FRAME.FadeIn:CreateAnimation("Alpha")
FTL_FOCUS_TARGET_FRAME.FadeIn.a1:SetFromAlpha(0)
FTL_FOCUS_TARGET_FRAME.FadeIn.a1:SetToAlpha(1)
FTL_FOCUS_TARGET_FRAME.FadeIn.a1:SetDuration(0.25)
FTL_FOCUS_TARGET_FRAME.FadeIn.a1:SetSmoothing("IN")
FTL_FOCUS_TARGET_FRAME.FadeIn.a1:SetOrder(1)
FTL_FOCUS_TARGET_FRAME.FadeIn:SetScript(
    "OnPlay",
    function()
        FTL_FOCUS_TARGET_FRAME:SetAlpha(1)
    end
)

--> Targeted Pulse
FTL_FOCUS_TARGET_FRAME.TargetedPulse = FTL_FOCUS_TARGET_FRAME:CreateAnimationGroup()
FTL_FOCUS_TARGET_FRAME.TargetedPulse:SetLooping("REPEAT")
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s1 = FTL_FOCUS_TARGET_FRAME.TargetedPulse:CreateAnimation("Scale")
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s1:SetFromScale(1, 1)
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s1:SetToScale(1.5, 1.5)
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s1:SetDuration(0.7)
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s1:SetOrder(1)
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s2 = FTL_FOCUS_TARGET_FRAME.TargetedPulse:CreateAnimation("Scale")
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s2:SetFromScale(1, 1)
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s2:SetToScale(0.75, 0.75)
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s2:SetDuration(0.7)
FTL_FOCUS_TARGET_FRAME.TargetedPulse.s2:SetOrder(2)

--|> FUNCTIONS
-----------------------------------------------------------------
--> Hide
function FTL_FOCUS_TARGET_FRAME.Hide()
    FTL_FOCUS_TARGET_FRAME:SetAlpha(0)
    FTL_FOCUS_TARGET_FRAME:ClearAllPoints()
    FTL_FOCUS_TARGET_FRAME:StopAnimating()
end

--> Show
function FTL_FOCUS_TARGET_FRAME.Show()
    local nameplate = C_NamePlate_GetNamePlateForUnit("focustarget")
    if nameplate then
        -- FTL_FOCUS_TARGET_FRAME.FadeIn:Play()
        FTL_FOCUS_TARGET_FRAME:SetPoint("BOTTOM", nameplate, "CENTER", 0, 30)
        FTL_FOCUS_TARGET_FRAME:SetAlpha(1)
        FTL_FOCUS_TARGET_FRAME:StopAnimating()
    else
        FTL_FOCUS_TARGET_FRAME.Hide()
    end
end

--> Show Assist
function FTL_FOCUS_TARGET_FRAME:ShowAssist()
    self.icon:SetVertexColor(1, 0, 0.2, 1)
    if self.TargetedPulse:IsPlaying() then
        self.TargetedPulse:Stop()
    end
end

--> Hide Assist
function FTL_FOCUS_TARGET_FRAME:HideAssist()
    self.icon:SetVertexColor(1, 0.49, 0, 1)
    self.TargetedPulse:Play()
end

--> Check For Assist
function FTL_FOCUS_TARGET_FRAME:CheckForAssist()
    if UnitIsUnit("target", "focustarget") then
        self:ShowAssist()
    else
        self:HideAssist()
    end
end
